
var ScoreMan={
	errorCode:0,
	errorMessage:null,
	integrityMode:0,
	init:function()
	{
		$("#cmdSave").bind("click",function(){
			ScoreMan.integrityMode=1;
			ScoreMan.processForm();
		});
		
		
	},
	acceptValue:function(id)
	{
		$("#"+id).removeClass("errorClass");
		ScoreMan.errorCode=0;
		ScoreMan.errorMessage=null;
		return true;
	},
	rejectValue:function(id,msg)
	{
		ScoreMan.errorCode=1;
		ScoreMan.errorMessage=msg;
		$("#"+id).addClass("errorClass");
		return false;
	},
	checkScoreIntegrity:function()
	{
		var frm=document.getElementById("ScoreForm");
		var inputData=frm.getElementsByTagName("input");
		for(var k=0;k<inputData.length;k++)
		{
			var e=inputData[k];
			if(e.type=="hidden" && e.id!="cmdResult" && e.id!="cmdSelection")
			{
				var t=e.id;
				 if(ScoreMan.integrityMode==1)
				 {
				 	//dealing with CA scores
				 	var caID=t+"-ca";
				 	var examID=t+"-exam";
				 	if(!ScoreMan.checkCA(caID))
				 	{
				 		break;
				 	}
				 	if(!ScoreMan.checkExam(examID))
				 	{
				 		break;
				 	}
				 	
				 }else
				 {
				 	//dealing with Exam scores
				 	//var examID=t+"-exam";
				 	//if(!ScoreMan.checkExam(examID))
				 	//{
				 	//	break;
				 	//}
				 }
			}else
			{
				continue;
			}
		}
		return;
		
	},
	checkCA:function(id)
	{
		var val=$("#"+id).val();
		var msg;
		if(isNaN(val))
		{
			msg="The highlighted CA score is not a valid score, must be a number";
			return ScoreMan.rejectValue(id,msg);
		}else
		{
			if(parseFloat(val)>40.0)
			{
		      msg="The highlighted CA score can not excede 40";
			  return ScoreMan.rejectValue(id,msg);
			}else if(parseFloat(val)<0)
			{
				msg="The highlighted CA score can not be lesss than zero";
			  return ScoreMan.rejectValue(id,msg);
			}
			else
			{
				return ScoreMan.acceptValue(id);
			}
		}
	},
	checkExam:function(id)
	{
		var val=$("#"+id).val();
		var msg;
		if(isNaN(val))
		{
			msg="The highlighted Exam score is not a valid score, must be a number";
			return ScoreMan.rejectValue(id,msg);
		}else
		{
			if(parseFloat(val)>60.0)
			{
		      msg="The highlighted Exam score can not excede 60";
			  return ScoreMan.rejectValue(id,msg);
			}else if(parseFloat(val)<0)
			{
				msg="The highlighted Exam score can not be less than 0";
			  return ScoreMan.rejectValue(id,msg);
			}else
			{
				return ScoreMan.acceptValue(id);
			}
		}
	},
	processForm:function()
	{
		ScoreMan.errorCode=0;
		var frm=document.getElementById("ScoreForm");
		if(frm.elements.length==0)
		{
			alert("There are no students records to work on");
			return;
		}
		
		ScoreMan.checkScoreIntegrity();
		if(ScoreMan.errorCode>0)
		{
			alert(ScoreMan.errorMessage);
			return;
		}else
		{
			//alert("The form is ready for submission");
			$("#statusBar").text("Saving records please wait...");
			frm.submit();
			return;
		}
		
	}
};

function loadCourseSelect(deptId)
{
	$.post("ajaxDispatcher.php",{departmentID:deptId},function(data){
		var child_data=data.getElementsByTagName('course');
		var targetObject=document.getElementById("csCourse");
		 if(targetObject.firstChild)
		 {
		 	while(targetObject.firstChild)
		 	{
		 		targetObject.removeChild(targetObject.firstChild);
		 	}
		 }
		 for(var i=0;i<child_data.length;i++)
		 {
		 	var optiontag=document.createElement("option");
	  	        optiontag.value=child_data[i].getAttribute('courseId');
	  	        optiontag.appendChild(document.createTextNode(child_data[i].getAttribute('courseCode')));
	  	        targetObject.appendChild(optiontag);                  
		 }
		 $("#csCourse").attr("disabled",false);
		   flashMessage(1,"");
		 
	});
}
function loadDepartmentSelect(fid)
{
	//clear the seelect box
	var targetObject=$("#csDepartment");
	 
	  $.post("ajaxDispatcher.php",{facultyID:fid},function(data){
	  	  //alert(data);
	  	  var child_nodes=data.getElementsByTagName('department');
	  	   //load the department select object
	  	   var myselect=document.getElementById("csDepartment");
	  	   //clear the object before loading it
	  	   if(myselect.firstChild)
	  	   {
	  	   	  while(myselect.firstChild)
	  	   	  {
	  	   	  	myselect.removeChild(myselect.firstChild);
	  	   	  }
	  	   }
	  	   for(var k=0;k<child_nodes.length;k++)
	  	   {
	  	       var optiontag=document.createElement("option");
	  	       
	  	           optiontag.value=child_nodes[k].getAttribute('deptId');
	  	       
	  	           optiontag.appendChild(document.createTextNode(child_nodes[k].getAttribute('deptName')));
	  	           myselect.appendChild(optiontag);                  
	  	          
	  	   }
	  	   //enable the department select object if it is loaded
	  	   $("#csDepartment").attr("disabled",false);
	  	   flashMessage(1,"");
	  });	
}
function loadStudySelect(deptId)
{
	//clear the seelect box
	var targetObject=$("#csStudy");
	 
	  $.post("ajaxDispatcher.php",{studyDepartmentID:deptId},function(data){
	  	  //alert(data);
	  	  var child_nodes=data.getElementsByTagName('study');
	  	   //load the department select object
	  	   var myselect=document.getElementById("csStudy");
	  	   //clear the object before loading it
	  	   if(myselect.firstChild)
	  	   {
	  	   	  while(myselect.firstChild)
	  	   	  {
	  	   	  	myselect.removeChild(myselect.firstChild);
	  	   	  }
	  	   }
	  	   for(var k=0;k<child_nodes.length;k++)
	  	   {
	  	       var optiontag=document.createElement("option");
	  	       
	  	           optiontag.value=child_nodes[k].getAttribute('studyId');
	  	       
	  	           optiontag.appendChild(document.createTextNode(child_nodes[k].getAttribute('studyName')));
	  	           myselect.appendChild(optiontag);                  
	  	           
	  	              
	  	              
	  	   }
	  	   //enable the department select object if it is loaded
	  	   $("#csStudy").attr("disabled",false);
	  	   flashMessage(1,"");
	  });
	  
}
function flashMessage(itype,msg)
{
	var ebar=document.getElementById("errorbar");
	switch(parseInt(itype))
	{
	  case 1:
	   //clear the message box and toggle the class
	   //$("#errorbar").html("");
	   //$("#errorbar").toggleClass("hidden-state");
	   ebar.innerHTML='';
	   ebar.className='hidden-state';
	   break;
	 case 2:
	   //set the error message of load state message
	    //$("#errorbar").html(" "+msg+" ");
	    //$("#errorbar").
	    ebar.innerHTML=msg;
	    ebar.className='active-state';
	    break;	
	}
	return;
}
function criteriaSelection()
{
	var frm=document.getElementById("SelectionForm");
	var errorArray=new Array();
	var selectData=document.getElementsByTagName("select");
	if(!selectData)
	{
		throw new Error("Could not get select objects");
	}
	
	for(var l=0;l<selectData.length;l++)
	{
		 var e=selectData[l];
		 
		 //	if(e.selectedIndex==0 || e.options[e.selectedIndex].value==undefined)
		 	//{
		 		//errorArray.push(e.id.substr(2));
		 		//break;
		 	//}
		 
	}
	
	if(errorArray.length>0)
	{
		alert("Please select "+ errorArray.pop()+" from the options");
		return;
	}else
	{
		frm.submit();
		return;
	}
}
$(document).ready(function(){
	ScoreMan.init();
	
	$("#csFaculty").change(function(){
		var theValue=$(this).val();
		if(theValue==0)
		{
			//$("#csDepartment").attr("disabled",true);
		}else
		{  
			flashMessage(2,"Loading departments please wait...");
			loadDepartmentSelect(theValue);
		}
		
	});
	//bind department change
	$("#csDepartment").change(function(){
		var theValue=$(this).val();
		if(theValue==0)
		{
			//$("#csCourse").attr("disabled",true);
		}else
		{
			flashMessage(2,"Loading course of study please wait...");
			loadStudySelect(theValue);
		}
	});
	$("#cmdLoad").bind("click",criteriaSelection);
});