<?php
// A class to handle simple pagination

class SimplePager
{
 var $limit;
 var $rows;
 var $url;
 var $max_listed_page;
 var $previous_prompt;
 var $next_prompt;
 var $page_num_param_index;
 var $current_display;
 
 function SimplePager($url)
 {
 	$this->limit=100;
 	$this->max_listed_page=10;
 	$this->previous_prompt="<< back";
 	$this->next_prompt="next >>";
 	$this->url=$url;
 	$this->page_num_param_index=1;
 	$this->current_display=array();
 }
 //sets the rows
 function setRows($rows)
 {
 	$this->rows=$rows;
 }
 //gets the page limit
 function get_limit()
 {
 	return $this->limit;
 }
 //displays the pager link
 function displayLinks($currPage=1,$listArray=array())
 {
 	$offset=($currPage -1)*$this->limit;
 	$row_count=sizeof($this->rows);
 	$total_pages=ceil($row_count/$this->limit);
 	@$rows=array_slice($this->rows,$offset,$this->limit);
 	$this->current_display=$rows;
 	
 	//will contain the pager links
 	$links=array();
 	if($currPage >1)
 	{
 		$prev_page=$currPage - 1;
 		$links[]="<span id='navseparator'><a href='$this->url?pager=$prev_page'>$this->previous_prompt</a></span>";
 	}else 
 	{
 		//no << back link if the visitor is on the first page
 		$links[]="<span id='navseparator'>".$this->previous_prompt."</span>";
 	}
 	//calculate the first and last listed pages
 	$start=floor($currPage/($this->max_listed_page))*$this->max_listed_page;
 	if(!$start)
 	{
 		$start=1;
 	}
 	$end=($total_pages <$start + ($this->max_listed_page -1))?
 	      $total_pages :$start + ($this->max_listed_page -1);
 	      
 	  //display pager
 	  for($i=$start;$i<=$end;$i++)
 	  {
 	  	 if($i!=$currPage)
 	  	 {
 	  	  $links[]="<span id='navseparator'><a href='$this->url?pager=$i'>$i</a></span>";
 	  	 }else 
 	  	 {
 	  	 	//no link to be displayed
 	  	 	$links[]="<span id='navseparator'>".$i."</span>";
 	  	 }
 	  }
 	  //display the next >> link
 	  if($currPage < $total_pages)
 	  {
 	  	$next_page=$currPage +1;
 	  	$links[]="<span id='navseparator'><a href='$this->url?pager=$next_page'>$this->next_prompt</a></span>";
 	  	
 	  }else 
 	  {
 	  	 $links[]="<span id='navseparator'>".$this->next_prompt."</span>";
 	  }
 	  //return the pager text
 	  return join("",$links);
 	
 }
 function get_data()
 {
 	return $this->current_display;
 }
 
}

?>