<?php

/**
 * Get all the sessions that a students ha registered for
 */

function get_student_registered_sessions(array $params)
{
   $sid=(isset($params['student_id']))?$params['student_id']:0;
   //the student id must be avaliable
    $status=array();
    $status['has_error']=0;
    $status['error_message']='';
    $status['data']=array();
    $session_data=array();
  global $connect;
    if(!$sid)
    {
    	$status['has_error']=1;
    	$status['error_message']="Missing student id for fetching registered sessions";
    	return $status;
    }

   $sql="SELECT DISTINCT
         cyearsession
        FROM course_reg
        WHERE std_id='$sid'
        ORDER BY cyearsession desc";

   $res=mysql_query($sql,$connect) or die(mysql_error());
   if(mysql_num_rows($res)>0)
   {
     // we have records get them
     while($d=mysql_fetch_assoc($res))
     {
		$session_data[]=$d['cyearsession'];
     }
		$status['data']=$session_data;
   }

   return $status;
}

function get_student_result_entries(array $params)
{ //var_dump($params);exit;
  global $connect;
  $status=array();
  $status['has_error']=0;
  $status['error_message']='';
  $status['entry']=array();
  $sessions=(count($params['registered_sessions'])>0)?$params['registered_sessions']:array();// var_dump($sessions);exit;
  $sid=(isset($params['student_id']))?$params['student_id']:0;
  sort($sessions); //var_dump($sessions);exit;
  //if any of these items are missing report error
  if(!count($sessions)||!$sid)
  {
  	$status['has_error']=1;
  	$status['error_message']="Missing required id and sessions for getting student data";
  	return $status;
  }
  //ok we have id and list of sessions pull records from students cgpa repository

  $sql="SELECT core_courses
              ,elective_courses
              ,student_level
              ,student_semester
              ,cgpa
              ,gpa
        FROM students_cgpa
        WHERE std_id='%d'
        AND session_id='%s'";
 //we pull this from the database
 $result_data=array();
 foreach($sessions as $ss)
 {
 //$msem = array('First Semester', 'Second Semester');
 //foreach($msem as $mm)
 //{

   $res=mysql_query(sprintf($sql,$sid,$ss),$connect);
   if(mysql_num_rows($res)>0)
   {
   	//we have records for this session
     $raw=array();
     $entry=new stdClass();
     while($d=mysql_fetch_assoc($res))
     {
       $entry->core=$d['core_courses'];
       $entry->elective=$d['elective_courses'];
       $entry->student_level=$d['student_level'];
       $entry->cgpa=$d['cgpa'];
       $entry->gpa=$d['gpa'];
       $entry->semester=$d['student_semester'];  
       //$raw[$d['student_semester']]=$entry;
	   $raw[]=$entry; //var_dump($entry);
   $result_data[$ss]=format_by_session($raw);
   } 
   }
      //order the result by session
        //var_dump($raw);
 }
//}
 $status['entry']=$result_data; //var_dump($status);
 return $status;
}

/**
 * Formats result entries for student
 * combining core and elective courses for a given session
 * into a single arrays container the courses,gpa,cgpa,gp,grade
 * and course units
 *
 * @param array $params
 * @return object {firstSemester:array(),secondSemester:array()}
 */
function format_by_session(array $params)
{
//var_dump($params);
  $cores=array();
  $electives=array();
  $status=new stdClass();
  $status->hasData=false;
  //first semester entries
  $status->firstSemester=array();
  //second semester entries
  $status->secondSemester=array();
  //first and second semester arrays
  $first_semester_entry=array();
  $second_semester_entry=array();
  $level=0;

  if(!count($params))
  {
  	return $status;
  }
  $status->hasData=true;
   foreach($params as $sim=>$entry)
   { //var_dump($entry->semester);
   
         switch((int)$sim)
         {
         	case 0:
         		//dealing with first semester entries
				  $first_semester_entry['cgpa']=$entry->cgpa;
				  $first_semester_entry['gpa']=$entry->gpa;
				  //$first_semester_entry['core']=unserialize($entry->core);
				  $cores=unserialize($entry->core);
				  $tmp_first=array();
				  //if we have any entry in this format it
				  if(count($cores))
				  {
				  	foreach($cores as $c)
				  	{
                        $tmp_first[$c->courseCode]=$c;
				  	}
				  }
				  //$first_semester_entry['elective']=unserialize($entry->elective);
				  $electives=unserialize($entry->elective);
                  //if any entry get it out
                   if(count($electives))
                   {
                   	foreach($electives as $e)
                   	{
						$tmp_first[$e->courseCode]=$e;
                   	}
                   	ksort($tmp_first);
                   }
                   $first_semester_entry['courses']=$tmp_first;
                   //the level
                   $first_semester_entry['level']=$entry->student_level;
                   $level=$entry->student_level;

         		break;
         	case 1:
         		//dealing with second semester entries
         		$second_semester_entry['cgpa']=$entry->cgpa;
         		$second_semester_entry['gpa']=$entry->gpa;
				//the core courses for this semester
				$cores=unserialize($entry->core);
				//do we have any
				$tmp_second=array();
				if(count($cores))
				{
					foreach($cores as $cc)
					{
						$tmp_second[$cc->courseCode]=$cc;
					}
				}
				//the elective if any
				$electives=unserialize($entry->elective);
    			//do we have something
    			if(count($electives))
    			{
    				foreach($electives as $ee)
    				{
    					$tmp_second[$ee->courseCode]=$ee;
    				}
    				ksort($tmp_second);
    			}
				$second_semester_entry['courses']=$tmp_second;
				$second_semester_entry['level']=$entry->student_level;
				$level=$entry->student_level;
         		break;
         }
   }
  // ksort($first_semester_entry['courses']);
  // ksort($second_semester_entry['courses']);
   $status->firstSemester=$first_semester_entry;
   $status->secondSemester=$second_semester_entry;
   $status->level=$level;//var_dump($status);exit;
   return $status; 
}

/**
 * Gets a students class of degree based
 * on their cgpa
 *
 * @param float $cgpa
 * @return string
 */
function get_class_of_degree($cgpa=0)
{
  $third_class="3<sup>rd</sup> CLASS DIVISION";
	$upper_class="2<sup>nd</sup> CLASS UPPER DIVISION";
	$lower_class="2<sup>nd</sup> CLASS LOWER DIVISION";
	$first_class="1<sup>st</sup> CLASS DIVISION";
	$pass_class="PASS";
	$fail_class="FAIL";


	$status=number_format($cgpa,2);

	if($status>=0 && $status<=0.99)
	{
		return $fail_class;
	}else if($status>=1.00 && $status<=1.49)
	{
		return $pass_class;
	}else if($status>=1.50 && $status<=2.39)
	{
		return $third_class;
	}else if($status>=2.40 && $status<=3.49)
	{
		return $lower_class;
	}else if($status>=3.50 && $status<=4.49)
	{
		return $upper_class;
	}else if($status>=4.50)
	{
		return $first_class;
	}

}



function find_student_for_result_statements(array $params)
{

  $str=(isset($params['search_string']))?$params['search_string']:'';
  $sid=(isset($params['session_id']))?$params['session_id']:0;
  $semester=(isset($params['semester_id']))?$params['semester_id']:'';
  $lid=(isset($params['level_id']))?$params['level_id']:0;
  $fid=(isset($params['faculty_id']))?$params['faculty_id']:0;
  $did=(isset($params['department_id']))?$params['department_id']:0;
  $status=array();
  $status['has_error']=0;
  $status['error_message']='';
  $status['data']=array();
  $query_type=0;
  $students=array();
  //$matregex="@[a-zA-Z0-9]";
  //$matregex="@(^[a-zA-Z]{1}+[0-9]{2})(.*?)[0-9]{4})@";
  $matregex='/^([a-zA-Z]{1}[0-9]{2})(.*?[0-9]{4})$/';

  if(!$str)
  {
  	$status['has_error']=1;
  	$status['error_message']="Please specify either name or matric number to search for";
  	return $status;
  }

  //are we dealing with matric number
  if(@preg_match($matregex,$str))
  {
  	$query_type=1;
  }
//filtering
global $connect;
    global $pager;
	$groupID=$_SESSION['groupID'];
	$facultyID=$_SESSION['myfaculty_id'];
	$departmentID=$_SESSION['mydepartment_id'];
	$where="";
	switch($groupID)
	{
		case 13:// PG Dean
		break;
		case 9:// Dean UG
		case 3://Faculty examination officer
			$where="AND p.stddepartment_id='$did'";
		    $where.="AND p.stdfaculty_id='$facultyID'";
		break;
		case 8://HOD
		case 21:// Departmental examination officer
		  $where="AND p.stdfaculty_id='$facultyID'";
		  $where.="AND p.stddepartment_id='$departmentID'";
		  break;
		  default://Others
		  $where="";
		  $where="AND p.stdfaculty_id='$fid'";
		  $where.="AND p.stddepartment_id='$did'";
	}


  $sql_name="SELECT
		    CONCAT(p.surname,' ',p.firstname,' ',p.othernames) AS name
		    ,p.std_id
			,p.matric_no
            ,d.departments_name
            ,f.faculties_name
            ,t.programme_option
			FROM students_profile AS p
			        LEFT JOIN faculties  AS f
			         ON f.faculties_id=p.stdfaculty_id
                      LEFT JOIN departments AS d
                       ON d.departments_id=p.stddepartment_id
                        LEFT JOIN dept_options AS t
                         ON t.do_id=p.stdcourse
			          WHERE (p.firstname ='$str'
			                 OR
			                 p.surname ='$str' OR p.matric_no = '$str'
			                 )
			          $where
			          GROUP BY p.matric_no ORDER BY p.surname,p.firstname";

  $sql_matno="SELECT
		    CONCAT(p.surname,' ',p.firstname,' ',p.othernames) AS name
		    ,p.std_id
			,p.matric_no
            ,d.departments_name
            ,f.faculties_name
            ,t.programme_option
			FROM students_profile AS p
			        LEFT JOIN faculties  AS f
			         ON f.faculties_id=p.stdfaculty_id
                      LEFT JOIN departments AS d
                       ON d.departments_id=p.stddepartment_id
                        LEFT JOIN dept_options AS t
                         ON t.do_id=p.stdcourse
			          WHERE p.matric_no='$str'
			          $where
			          GROUP BY p.matric_no ORDER BY p.surname,p.firstname";

   //if query type is set we are dealing with matric number
  // echo $sql_name;
   //exit;
   if($query_type)
   {
   	  $ret=mysql_query($sql_matno) or die(mysql_error($connect));
   }else
   {
   	$ret=mysql_query($sql_name) or die(mysql_error($connect));
   }

   if(mysql_num_rows($ret)>0)
   {
   	//we have a result
   	 $status['has_record']=1;
   	 while($d=mysql_fetch_assoc($ret))
           {
               $s=new stdClass();
               $s->studentName=$d['name'];
               $s->studentId=$d['std_id'];
               $s->studentFaculty=$d['faculties_name'];
               $s->studentDepartment=$d['departments_name'];
               $s->studentProgramme=$d['programme_option'];
               $s->studentMatricno=$d['matric_no'];
               $students[]=$s;
           }


   }else
   {
   	$status['has_error']=1;
   	$status['error_message']="No record found for $str, please refine your search";
   }

   $pager->setRows($students);
       //keep track of the level,session and the semester we use that in generating the statement
       $status['semester']=$semester;
       $status['level']=$lid;
       $status['session']=$sid;
       $status['data']=$students;

   return $status;

}
/**
 * Gets lists of students for generating
 * statement of results
 *
 * @param array $params
 * @return array
 */
function list_students_for_result_statements(array $params)
{
  $status=array();
  $status['has_error']=0;
  $status['error_message']='';
  $status['data']=array();
  $students=array();
  //the session id
  $sid=isset($params['session_id'])?$params['session_id']:0;
  //the faculty id
  $fid=isset($params['faculty_id'])?$params['faculty_id']:0;
  //the department id
  $did=isset($params['department_id'])?$params['department_id']:0;
  //level id
  $lid=isset($params['level_id'])?$params['level_id']:0;
  //semester we are interested in
  $semester=isset($params['semester_id'])?$params['semester_id']:'';
  //the study id we are interested in
  $studyid=isset($params['study_id'])?$params['study_id']:0;

  //if we do not have any of these keys return error
  if(!$sid||!$fid||!$did||!$lid||!$semester||!$studyid)
  {
  	$status['has_error']=1;
  	$status['error_message']="Missing a required field in fetching list of students";
  	return $status;
  }

  //we need to get student based on faculty,department and study field

    global $connect;
    global $pager;
	$groupID=$_SESSION['groupID'];
	$facultyID=$_SESSION['myfaculty_id'];
	$departmentID=$_SESSION['mydepartment_id'];
	$where="";
	switch($groupID)
	{
		case 13:// PG Dean
		break;
		case 9:// Dean UG
		case 3://Faculty examination officer
			$where="AND p.stddepartment_id='$did'";
		    $where.="AND p.stdfaculty_id='$facultyID'";
		break;
		case 8://HOD
		case 21://Departmental examination officer
		  $where="AND p.stdfaculty_id='$facultyID'";
		  $where.="AND p.stddepartment_id='$departmentID'";
		  break;
		  default://Others
		  $where="";
		  $where="AND p.stdfaculty_id='$fid'";
		  $where.="AND p.stddepartment_id='$did'";
	}

	$sql="SELECT
		    CONCAT(p.surname,' ',p.firstname,' ',p.othernames) AS name
		    ,p.std_id
			,p.matric_no
            ,d.departments_name
            ,f.faculties_name
            ,t.programme_option
			FROM students_profile AS p
			        LEFT JOIN faculties  AS f
			         ON f.faculties_id=p.stdfaculty_id
                      LEFT JOIN departments AS d
                       ON d.departments_id=p.stddepartment_id
                        LEFT JOIN dept_options AS t
                         ON t.do_id=p.stdcourse
			          WHERE p.stdcourse='$studyid' AND p.std_custome1 ='$lid' AND (p.std_custome9 != p.matric_no)
			          $where
			          GROUP BY p.matric_no ORDER BY p.surname,p.firstname";


	  $res =mysql_query($sql,$connect) or die(mysql_error());
       if(mysql_num_rows($res)>0)
       {
           while($d=mysql_fetch_assoc($res))
           {
               $s=new stdClass();
               $s->studentName=$d['name'];
               $s->studentId=$d['std_id'];
               $s->studentFaculty=$d['faculties_name'];
               $s->studentDepartment=$d['departments_name'];
               $s->studentProgramme=$d['programme_option'];
               $s->studentMatricno=$d['matric_no'];
               $students[]=$s;
           }
       }
       $pager->setRows($students);
       //keep track of the level,session and the semester we use that in generating the statement
       $status['semester']=$semester;
       $status['level']=$lid;
       $status['session']=$sid;
       $status['data']=$students;
       return $status;
}
/**
 * Get lists of students for whom transcripts can be generated for
 *
 * @param array $params
 * @return array
 */
function list_students_for_transcripts(array $params)
{
  $status=array();
  $status['has_error']=0;
  $status['error_message']='';
  $status['data']=array();

  $students=array();
  //session id
  $sid=(isset($params['session_id']))?$params['session_id']:0;
  //field of study id
  $studyid=(isset($params['study_id']))?$params['study_id']:0;
  //faculty id
  $fid=(isset($params['faculty_id']))?$params['faculty_id']:0;
  //department id
  $did=(isset($params['department_id']))?$params['department_id']:0;

  //if we are missing any of these return error
  if(!$sid||!$studyid||!$fid||!$did)
  {
  	$status['has_error']=1;
  	$status['error_message']="Missing required parameters for fetching student list";
  	return $status;
  }

  //ok we have data
    global $connect;
    global $pager;
	$groupID=$_SESSION['groupID'];
	$facultyID=$_SESSION['myfaculty_id'];
	$departmentID=$_SESSION['mydepartment_id'];
	$where="";
	switch($groupID)
	{
		case 13:// PG Dean
		break;
		case 9:// Dean UG
		case 3://Faculty examination officer
			$where="AND p.stddepartment_id='$did'";
		    $where.="AND p.stdfaculty_id='$facultyID'";
		break;
		case 8://HOD
		case 21://Departmental examination officer
		  $where="AND p.stdfaculty_id='$facultyID'";
		  $where.="AND p.stddepartment_id='$departmentID'";
		  break;

		  default://Others
		  $where="";
		  $where="AND p.stdfaculty_id='$fid'";
		  $where.="AND p.stddepartment_id='$did'";
	}
     $where.=" AND p.stdcourse='$studyid'";
	$sql="SELECT
		    CONCAT(p.surname,' ',p.firstname,' ',p.othernames) AS name
		    ,p.std_id
			,p.matric_no
            ,d.departments_name
            ,f.faculties_name
            ,t.programme_option
			FROM students_profile AS p
			        LEFT JOIN faculties  AS f
			         ON f.faculties_id=p.stdfaculty_id
                      LEFT JOIN departments AS d
                       ON d.departments_id=p.stddepartment_id
                        LEFT JOIN dept_options AS t
                         ON t.do_id=p.stdcourse
			         WHERE p.std_id IN
			          (
			          	SELECT std_id FROM graduated_students
			          	WHERE grad_session='$sid'
			          	AND grad_faculty_id='$fid'
			          	AND grad_department_id='$did'
			          )
			          $where
			          GROUP BY p.matric_no ORDER BY p.surname,p.firstname";


	  $res =mysql_query($sql,$connect) or die(mysql_error());
       if(mysql_num_rows($res)>0)
       {
           while($d=mysql_fetch_assoc($res))
           {
               $s=new stdClass();
               $s->studentName=$d['name'];
               $s->studentId=$d['std_id'];
               $s->studentFaculty=$d['faculties_name'];
               $s->studentDepartment=$d['departments_name'];
               $s->studentProgramme=$d['programme_option'];
               $s->studentMatricno=$d['matric_no'];
               $students[]=$s;
           }
       }
       $pager->setRows($students);
       $status['data']=$students;
       return $status;

}

function get_a_student_details_for_transcript(array $params)
{
  global $connect;
  $student=new stdClass();
 $student->hasData=false;
  $sid=(isset($params['student_id']))?$params['student_id']:0;
  if(!$sid)
  {
  	return $student;
  }
 $sql="";
 $sql="SELECT
       p.matric_no
       ,CONCAT(p.firstname,' ',p.othernames,' ',p.surname) AS name
       ,p.gender
       ,p.birthdate
       ,p.nationality
       ,s.state_name
       ,d.degree_name
       ,t.programme_option
       ,p.std_custome18
       ,f.faculties_name
       ,u.departments_name
       FROM students_profile AS p
         LEFT JOIN faculties AS f
           ON f.faculties_id=p.stdfaculty_id
             LEFT JOIN state AS s
               ON s.state_id=p.state_of_origin
                 LEFT JOIN degree as d
                   ON d.degree_id=p.stddegree_id
                    LEFT JOIN departments AS u
                      ON u.departments_id=p.stddepartment_id
                        LEFT JOIN dept_options AS t
                          ON t.do_id=p.stdcourse

        WHERE p.std_id='$sid'
       ";
    $res=mysql_query($sql,$connect)or die(mysql_error());
    if(mysql_num_rows($res)>0)
    {
        $student->hasData=true;
        while($d=mysql_fetch_assoc($res))
        {
           $student->studentName=strtoupper($d['name']);
           $student->studentFaculty=$d['faculties_name'];
           $student->studentDepartment=$d['departments_name'];
           $student->studentProgramme=$d['programme_option'];
           $student->studentBirthdate=formatDate($d['birthdate']);
           $student->studentEntryyear=$d['std_custome18'];
           $student->studentNationality=$d['nationality'];
           $student->studentState=$d['state_name'];
           $student->studentMatricno=$d['matric_no'];
           $student->studentGender=$d['gender'];

        }
    }

    return $student;
}
/*format date of birth */
function formatDate($dob)
{
	$str=strtotime($dob);
	return date("F jS,Y",$str);
}

function get_a_student_result_statement(array $params)
{
  global $connect;
  $status=array();
  $status['has_error']=0;
  $status['error_message']='';
  	$status['has_record']=0;
  	$status['course_info']=array();
  	$status['cgpa_info']=array();
  	$status['student_info']='';
  	//for querying for previous result
  	$param2=array();
  //the session id
  $sid=isset($params['session_id'])?$params['session_id']:0;
  $param2['session_id']=$sid;
  //the semester we are interested in
  $semester=isset($params['semester_id'])?$params['semester_id']:'';
  $param2['semester']=$semester;
  //the level we are interested in
  $lid=isset($params['level_id'])?$params['level_id']:0;
  $param2['level_id']=$lid;
  //the student id
  $id=isset($params['student_id'])?$params['student_id']:0;
  $param2['student_id']=$id;
  // verify parameters
  if(!$id||!$sid||!$semester||!$lid)
  {
  	//we have an error
  	$status['has_error']=1;
  	$status['error_message']="Missing a required parameters for fetching satement of result";

  	return $status;
  }
  //load the data
  $sql="SELECT
         CONCAT(p.surname,' ',p.firstname,' ',p.othernames) AS name
         ,p.matric_no
         ,l.level_name
         ,t.programme_option
        FROM students_profile AS p
             ,dept_options AS t
             ,level AS l
        WHERE p.stdcourse=t.do_id
              AND p.std_custome1=l.level_id
              AND p.std_id='$id'
              ";

  //load the student info
  $ret=mysql_query($sql);
  if(mysql_num_rows($ret)>0)
  {
  	$status['has_record']=1;
    while($d=mysql_fetch_assoc($ret))
    {
        $s=new stdClass();
        $s->studentName=$d['name'];
        $s->studentMatricno=$d['matric_no'];
        $s->studentLevel=$d['level_name'];
        $s->studentProgramme=$d['programme_option'];
        $status['student_info']=$s;
    }
  }
  //ok we need to look for the result for the criteria
  $result=array();
  $result2=array();
$result2=get_student_previous_cgpa_entry($param2);
$result=get_student_current_cgpa_entry($param2); //var_dump($result2);
 //check if we have an error
  if($result2['has_error']!==0)
  {
  	//we have an error
  	$status['has_error']=1;
  	$status['error_message']=$result['error_message'];
  	return $status;
  }
  //check if we have a record
  /*if($result2['has_record']==0)
  {
  	//for some reason we could get any result
  	$status['has_error']=1;
  	$status['error_message']="We could not get this student statement of result";
  	return $status;
  }  */
  $previous=$result2['previous_result'];
  
  $result=get_student_current_cgpa_entry($param2);
 //check if we have an error
  if($result['has_error']!==0)
  {
  	//we have an error
  	$status['has_error']=1;
  	$status['error_message']=$result['error_message'];
  	return $status;
  }
  //check if we have a record
  if($result['has_record']==0)
  {
  	//for some reason we could get any result
  	$status['has_error']=1;
  	$status['error_message']="We could not get this student statement of result";
  	return $status;
  }
  //if we get to this place we have the result
  $cores=array();
  $electives=array();
  $current=array();
  $current=$result['current_result']; //var_dump($current);exit;
  //this must be an array
  if(!count($current))
  {
  	$status['has_error']=1;
  	$status['error_message']="could not read current cgpa entries for this student";
  	return $status;

  }

  $cores=$current['core_courses'];
  $electives=$current['elective_courses'];
  $courses_taken=array();
  //if we have core courses
  if(count($cores))
  {
  	foreach($cores as $k1=>$v1)
  	{
       $c1=new stdClass();
       $c1->courseCode=$v1->courseCode;
       $c1->courseGrade=$v1->grade;
       //check the score of the course to determine the status of the course
       $score=0;
       $score=(int)$v1->score;
       if($score<40)
       {
       	$c1->status="Fail";
       }else
       {
       	 $c1->status="Pass";
       }
       $courses_taken[]=$c1;
  	}
  }
  //check the electives
  if(count($electives))
  {
  	foreach($electives as $k2=>$v2)
  	{
  		$c2=new stdClass();
  		$c2->courseCode=$v2->courseCode;
  		$c2->courseGrade=$v2->grade;
  		//check the score to determine the status
  		$score=0;
  		$score=(int)$v2->score;
  		if($score<40)
  		{
  			$c2->status="Fail";

  		}else
  		{
  			$c2->status="Pass";
  		}
  		$courses_taken[]=$c2;
  	}
  }

  $status['course_info']=$courses_taken;
  $status['cgpa_info']=$current;
  $status['cgpa_info_previous']=$previous;
  return $status;
}

function get_courseTitle_based_on_coursecode($cid)
{ 
    global $connect,$_SESSION;
	

	$sql="SELECT DISTINCT thecourse_title
			FROM courses 
			WHERE thecourse_code='$cid'
			 ";

	$res=mysql_query($sql,$connect) or die(mysql_error());
	if(mysql_num_rows($res)>0)
	{
		$d=mysql_fetch_assoc($res);
			$thecourse_title=$d['thecourse_title'];		
			$result=$thecourse_title; 
	
	}//var_dump($result);exit;
	return $result;
}
function firstcourse(array $params){
global $connect,$_SESSION;
$firstcourses = array();
$firstcourses['courses'] = array();
//var_dump($params);
$student_id=(isset($params['student_id']))?$params['student_id']:0;
$session_id=(isset($params['session_id']))?$params['session_id']:0;
$semester_id=(isset($params['semester_id']))?$params['semester_id']:0;
$level_id=(isset($params['level_id']))?$params['level_id']:0;

$sqlc = "SELECT * FROM students_results as s 
where  s.std_id='$student_id' AND s.std_mark_custom2='$session_id' 
AND s.std_mark_custom1='$semester_id' AND s.level_id='$level_id' order by s.level_id
"; 
$resc = mysql_query($sqlc,$connect) or die(mysql_error());
if(mysql_num_rows($resc)>0)
{
while($rowc = mysql_fetch_assoc($resc))
{
	$entry=new stdClass();
	
	$entry->student_id=$rowc['std_id'];
	$entry->course_name=$rowc['stdcourse_id'];
	$entry->course_code=$rowc['stdcourse_id'];
	$entry->std_ca=$rowc['std_ca'];
	$entry->std_exam=$rowc['std_exam'];
	$entry->std_mark=$rowc['std_mark'];
	$entry->std_grade=$rowc['std_grade'];
	$entry->cu=$rowc['cu'];
	$entry->cp=$rowc['cp'];
	
	$result[]=$entry;
	
}

}//var_dump($result);exit;
return $result; 
}

function get_course_code_title($course_id, $std_id, $status)
{
global $connect,$_SESSION;
$sqlc = "SELECT * FROM course_reg where std_id='$std_id' AND thecourse_id='$course_id' limit 1"; 
$resc = mysql_query($sqlc,$connect) or die(mysql_error());
if(mysql_num_rows($resc)>0)
{
	$rowc = mysql_fetch_assoc($resc);
	$course_name = $rowc['stdcourse_custom1'];
	$course_code = $rowc['stdcourse_custom2'];
		if($status=='name'){
			$result=$course_name;
		}else{
			$result=$course_code;
		}
}

return $result;
}	
function get_gpa_cgpa(array $params)
{
global $connect,$_SESSION;
$student_id=(isset($params['student_id']))?$params['student_id']:0;
$session_id=(isset($params['session_id']))?$params['session_id']:0;
$semester_id=(isset($params['semester_id']))?$params['semester_id']:0;
$level_id=(isset($params['level_id']))?$params['level_id']:0;

$sqlc = "SELECT * FROM students_cgpa where std_id='$student_id' AND session_id='$session_id' 
AND student_level='$level_id' AND student_semester='$semester_id'"; 
$resc = mysql_query($sqlc,$connect) or die(mysql_error());

if(mysql_num_rows($resc)>0)
{
while($rowc = mysql_fetch_assoc($resc))
{
	$result=array();
	$entry=array();
	
	$entry['gpa'] = $rowc['gpa'];
	$entry['cgpa'] = $rowc['cgpa'];
	
	$result=$entry;
	
}
//var_dump($result);
}
return $result;
}	

function get_cum_cgpa(array $params)
{
global $connect,$_SESSION;
$student_id=(isset($params['student_id']))?$params['student_id']:0;
$session_id=(isset($params['session_id']))?$params['session_id']:0;
$semester_id=(isset($params['semester_id']))?$params['semester_id']:0;
$level_id=(isset($params['level_id']))?$params['level_id']:0;

$sqlc = "SELECT sum(cu) as cu, sum(cp) as wgp FROM students_results where std_id='$student_id'"; 
$resc = mysql_query($sqlc,$connect) or die(mysql_error());

if(mysql_num_rows($resc)>0)
{
while($rowc = mysql_fetch_assoc($resc))
{
	$result=array();
	$entry=array();
	
	$entry['cu'] = $rowc['cu'];
	$entry['wgp'] = $rowc['wgp'];
	
	$result=$entry;
	
}
//var_dump($result);
}
return $result;
}	


function get_a_student_ca_result_statement (array $params){
	
	global $connect ;
	 $status=array();
  	$status['has_error']=0;
  	$status['error_message']='';
  	$status['has_record']=0;
  	$status['course_info']=array();
  	$status['cgpa_info']=array();
  	$status['student_info']='';
  	//for querying for previous result
  	$param2=array();
  //the session id
  $sid=isset($params['session_id'])?$params['session_id']:0;
  $param2['session_id']=$sid;
  //the semester we are interested in
  $semester=isset($params['semester_id'])?$params['semester_id']:'';
  $param2['semester']=$semester;
  //the level we are interested in
  $lid=isset($params['level_id'])?$params['level_id']:0;
  $param2['level_id']=$lid;
  //the student id
  $id=isset($params['student_id'])?$params['student_id']:0;
  $param2['student_id']=$id;
  // verify parameters
  if(!$id||!$sid||!$semester||!$lid)
  {
  	//we have an error
  	$status['has_error']=1;
  	$status['error_message']="Missing a required parameters for fetching satement of result";

  	return $status;
  }
 
 $sql="SELECT
         CONCAT(p.surname,' ',p.firstname,' ',p.othernames) AS name
         ,p.matric_no
         ,l.level_name
         ,t.programme_option
        FROM students_profile AS p
             ,dept_options AS t
             ,level AS l
        WHERE p.stdcourse=t.do_id
              AND p.std_custome1=l.level_id
              AND p.std_id='$id'
              ";

  //load the student info
  $ret=mysql_query($sql,$connect);
  if(mysql_num_rows($ret)>0)
  {
  	$status['has_record']=1;
    while($d=mysql_fetch_assoc($ret))
    {
        $s=new stdClass();
        $s->studentName=$d['name'];
        $s->studentMatricno=$d['matric_no'];
        $s->studentLevel=$d['level_name'];
        $s->studentProgramme=$d['programme_option'];
        $status['student_info']=$s;
    }
  }
  //ok we need to look for the result for the criteria
  $result=array();
  $result = get_student_ca($params);var_dump($result);exit;
  
	
	}
	
	
	function get_student_ca(array $data)
{   

	$status=array();
	$status['has_error']=0;
	$status['error_message']='';
	$status['has_record']=0;
	$status['previous_result']=array();
    global $connect;
	$std_id=(isset($data['student_id']))?$data['student_id']:0;
	$level=(isset($data['level_id']))?$data['level_id']:0;
	$semester=(isset($data['semester_id']))?$data['semester_id']:'';
	$session_id=(isset($data['session_id']))?$data['session_id']:0;

	//there are parameters that must never be empty
	if(!$std_id||!$level||!$semester||!$session_id)
	{
		//an error
		$status['has_error']=1;
		$status['error_message']="Missing a required parameters for fetching student previous result";
		return $status;
	}

   switch(strtolower($semester))
   {
   	case'first semester':
   	  // we need to check  previous session,second semester,at a level 1 less than the current level
   	   if($level>1)
   	   {
   	   	$level=$level;
   	   }
   	   if($session_id)
   	   {
   	   	$session_id=$session_id;
   	   }
   	   $semester="second semester";

   	break;
   	case'second semester':
   	// we need to check previous semester,same level,same session
   	   $semester="first semester";
   	break;
   }

   $sql="SELECT * FROM students_ca
        WHERE std_id='$std_id'
        AND level_id='$level'
        AND semester='$semester'
        AND session_id='$session_id'
		LIMIT 1
        ";
     
     $ret=mysql_query($sql,$connect) or die(mysql_error());//$d=mysql_fetch_assoc($ret);var_dump($d);exit;

     if(mysql_num_rows($ret)>0)
     {
     	$status['has_record']=1;
     	//we process the records found
     	while($d=mysql_fetch_array($ret))
     	{
			$entry=array();
			$entry['matric_no']=$d['matric_no'];
			$entry['course_id']=$d['course_id'];
			$entry['ca1']=$d['ca1'];
			$entry['ca2']=$d['ca2'];
			$entry['ca3']=$d['ca3'];
			$entry['total']=$d['total'];
			
     	}
     	$status['previous_result']=$entry;
     }
     //var_dump($entry);exit;
     return $status;
}

?>